import { Meta, Preview, Props, Story } from '@storybook/addon-docs/blocks';
import { DependenciesTable } from 'storybook-addon-deps/blocks';
import { withKnobs, text, object } from '@storybook/addon-knobs';

import ABadgeUi from './ABadgeUi.vue';

<Meta
  title="Core/Atoms/ABadgeUi"
  component={ABadgeUi}
  parameters={{ component: ABadgeUi }}
/>

# A-Badge-Ui

A large rounded badge.

<Preview>
  <Story name="default" decorators={[withKnobs]}>
    {{
      components: { ABadgeUi },
      props: {
        label: { default: text('default', 'Badge', 'Slots') },
        styles: {
          default: () => object(
            'CSS Variables',
            {
              '--a-badge-ui--bg-color': '#f4f5f7',
              '--a-badge-ui--text-color': '#252f3f',
            },
            'Styles'
          ),
        },
      },
      template: '<a-badge-ui :style="styles">{{ label }}</a-badge-ui>',
    }}
  </Story>
</Preview>

## API

<Props of={ABadgeUi} />

## Installation

```bash
yarn add -E @bit/adakode.ak-ui.core.atoms.a-badge
```

## Usage

```html
<!-- Basic Badge -->
<a-badge-ui>Badge</a-badge-ui>
```

## Customization

There are several ways to customize the look and feel of the component,
depending on the desired scope of the customization.

### Global Customization

To customize the look and feel of **every single instance** of the component create a css file
defining a class named after the kebab-case version of the component name
and define any of the custom properties below:

| CSS variable               |   default | design token               |
| :------------------------- | --------: | :------------------------- |
| `--a-badge-ui--bg-color`   | `#f4f5f7` | `theme('colors.gray.100')` |
| `--a-badge-ui--text-color` | `#252f3f` | `theme('colors.gray.800')` |

These are the steps:

```bash
mkdir -p src/assets/styles/components/ui/core/atoms && touch $_/ABadgeUi.css
```

```css
/* <rootDir>/src/assets/styles/components/index.css */
@import './ui/core/atoms/ABadgeUi.css';
```

```css
/* <rootDir>/src/assets/styles/components/ui/core/atoms/ABadgeUi.css */
.a-badge-ui {
  --a-badge-ui--bg-color: theme('colors.gray.100');
  --a-badge-ui--text-color: theme('colors.gray.800');
}
```

### Scoped Customization

To customize the look and feel of a **group of instances** of the component
augment the specificity of the component class with a scoping class:

```css
/* <rootDir>/src/assets/styles/components/ui/core/atoms/ABadgeUi.css */
.a-badge-ui.a-badge-ui--success {
  --a-badge-ui--bg-color: theme('colors.green.100');
  --a-badge-ui--text-color: theme('colors.green.800');
}
.a-badge-ui.a-badge-ui--error {
  --a-badge-ui--bg-color: theme('colors.red.100');
  --a-badge-ui--text-color: theme('colors.red.800');
}
```

```html
<!-- <rootDir>/src/components/path/to/the/ConsumerComponent.vue -->
<a-badge-ui class="a-badge-ui--success">Success</a-badge-ui>
<a-badge-ui class="a-badge-ui--error">Error</a-badge-ui>
```

### Instance Customization

To customize the look and feel of a **single instance** of the component
you can define the desired CSS variables inline:

```html
<!-- Using CSS variables -->
<a-badge-ui
  :style="{
    '--a-badge-ui--bg-color': '#f4f5f7',
    '--a-badge-ui--text-color': '#252f3f',
  }"
>
  Badge
</a-badge-ui>
```

or use the proper utility classes after a `reset` class:

```html
<!-- Using utility classes -->
<a-badge-ui class="reset bg-gray-100 text-gray-800">
  Badge
</a-badge-ui>
```

## Dependencies

<DependenciesTable
  titleDependencies="Dependencies"
  titleDependents="Dependents"
  of={ABadgeUi}
/>

## Links

Source: https://gitlab.com/adakodecoop/coop/adakode-ui/-/tree/master/src/components/ui/core/atoms/ABadge  
Bit: https://bit.dev/adakode/ak-ui/core/atoms/a-badge  
Tailwind UI: https://tailwindui.com/components/application-ui/elements/badges#component-3bd45479320e729ad24717856b8c5340
